;;; Project:           Scheme-PG
;;; Author:            David J. Neu, djneu@acm.org
;;; Maintainer:        David J. Neu, djneu@acm.org
;;; Project Home Page: http://scheme-pg.sourceforge.net
;;; Copyright:         Copyright (c) 2004 Universal Technical Resource Services, Inc.
;;; License:           MIT License, see license.txt
;;; CVS Id:            $Id: scheme-pg.ss,v 1.2 2004/09/16 17:43:00 djneu Exp $

(module scheme-pg mzscheme
  (require "s-pg.scm")
  (require "cursor.scm")
  (require "stream.scm")
  (require "sql.scm")  
  (provide
   ;; from s-pg
   connection-open
   connection?
   connection-close
   execute-sql
   result-open
   result?
   result-ref
   result-length
   result-metadata
   result-close
   escape-string

   ;; from cursor
   cursor
   cursor-open
   #| !!! cursor-metadata |#
   cursor-ref!
   cursor-ref
   cursor-next
   cursor-previous
   cursor-first
   cursor-last
   cursor-length
   eoc-object?
   cursor-close

   ;; from stream
   stream-delay
   stream-force
   stream-cons
   stream-car
   stream-cursor
   stream-cdr
   null-stream
   stream-null?
   stream->list
   stream
   stream-ref
   stream-ref!
   #| stream-metadata |#
   stream-length

   ;; from sql
   where
   select
   limit
   order-by
   distinct
   insert
   update
   delete))

;;; *EOF*
