;;; -*- Scheme -*-

;;;; Przyklad uzycia w MzScheme interfejsu Libpq dla Postgresa.

(require (lib "libpq-fe.scm" "libpq"))

(define (libpq-example)
  ;; Polacz sie z baza danych.  Jesli jakies parametry zostaly pominiete,
  ;; system sprobuje pobrac ich wartosci ze srodowiska, a jesli to zawiedzie,
  ;; uzyje ustalonych wartosci domyslnych.
  (let ((conn (PQ-connectdb "dbname=bd user=scott password=tiger")))  ; host=libdb
    ;; Sprawdz, czy udalo sie polaczyc.
    (cond ((= (PQ-status conn) CONNECTION-BAD)
           (fprintf (current-error-port) "Connection to database failed.\n")
           (fprintf (current-error-port) "~a" (PQ-error-message conn)))
          (else
           ;; Spytaj o imie zwierzaka.
           (printf "Podaj imie zwierzaka: ")
           (let* ((imie (read-line))
                  ;; Wyslij zapytanie.
                  (res
                   (PQ-exec conn
                            (format "SELECT waga FROM zwierz WHERE imie = '~a'"
                                    imie))))
             ;; Sprawdz odpowiedz.
             (cond ((not (= (PQ-result-status res) PGRES-TUPLES-OK))
                    (fprintf (current-error-port) "Blad zapytania\n"))
                   ((> (PQ-ntuples res) 0)
                    ;; Wypisz wage.
                    (printf "~a wazy ~a kg.\n" imie (PQ-getvalue res 0 0)))
                   (else
                    (printf "Nie ma takiego zwierzaka\n")))
             (PQ-clear res))))
    ;; Zamknij polaczenie z baza danych.
    (PQ-finish conn)))

;;; *EOF*
