;;;; Scheme Language Interface (libpq) sample program

(require (lib "libpq-fe.scm" "libpq"))
(require (lib "etc.ss"))

(define (test-select)
  (let* ((connection-str "dbname=bd user=scott password=tiger")  ;host=labdb 
         (conn (PQ-connectdb connection-str)))
    (let/ec break
      (cond ((= (PQ-status conn) CONNECTION-BAD)
             (fprintf (current-error-port)
                      "Connection to ~a failed, ~a" connection-str
                      (PQ-error-message conn))
             (break #f))
            (else
             (printf "Connected OK~%")
             (let ((result
                    (PQ-exec conn
                             "SELECT gatunek, przysmak FROM Gatunki WHERE kontynent = 'Europa'")))
               (cond ((not result)
                      (printf "PQ-exec command failed, no error code~%")
                      (break #f))
                     (else
                      (evcase (PQ-result-status result)
                        (PGRES-COMMAND-OK
                         (printf "Command executed OK, ~a rows affected~%"
                                 (PQ-cmd-tuples result)))
                        (PGRES-TUPLES-OK
                         (printf "Query was OK and returned ~a rows~%"
                                 (PQ-ntuples result)))
                        (else
                         (printf "Command failed with code ~a, error message ~a~%"
                                 (PQ-res-status (PQ-result-status result))
                                 (PQ-result-error-message result))
                         (PQ-clear result)
                         (break #f)))))
               (let ((output-stream (fopen "/dev/tty" "w")))
                 (unless output-stream
                   (PQ-clear result)
                   (break #f))
                 (let ((print-options
                        (make-PQ-print-opt #t     ;print headers          :header
                                           #t     ;align fields           :align
                                           #f     ;output as html tables  :html3
                                           "|"    ;field separator        :field-sep
                                           #| #f |#)))  ;alternate field names  :field-name
                   (PQ-print output-stream result print-options)))
               (when result (PQ-clear result))))))
    (when conn (PQ-finish conn))))

;;; *EOF*
